import numpy as np
import scipy.optimize as opt
from sklearn import svm, preprocessing
import matplotlib.pyplot as plt
def sigmoid(X):
    '''sigmoid function '''
    return 1/(1+np.exp(-X))

def cost(theta, X, y, lmd):
    '''  regularized logistic regression cost    '''
    sxt = sigmoid(np.dot(X, theta));
    mcost = (-y)*np.log(sxt) - (1-y)*np.log(1-sxt) + lmd/2 * np.dot(theta.T,theta);
    return mcost.mean()  


def predict(theta, X):
    #test new data
    m, n = X.shape
    p = np.zeros(shape=(m, 1));
    h = sigmoid(X.dot(theta.T));
    p = 1*(h>=0.5);
    return p      
#load the dataset
puredata = np.loadtxt('training_data.csv', delimiter=',');
#separate attributes x from class labels
X = puredata[:,1:];
Y = puredata[:,0];
#normalize
XN = preprocessing.scale(X);
#append "1's" to attributes first column
XX = np.append( np.ones((XN.shape[0], 1)), XN, axis=1);
m , n = XX.shape;
#create initial theta values
theta = 0.1* np.random.randn(n);
#initial lambda
lmd = 0.005;
#use fmin_bfgs optimisation function find thetas
theta = opt.fmin_bfgs(cost, theta, args=(XX, Y, lmd));
#test on labeled data
testpuredata = np.loadtxt('test_data.csv', delimiter=',');
#separate attributes x from class labels
TX = testpuredata[:,1:];
TY = testpuredata[:,0];
#normalize
TXN = preprocessing.scale(X);
#append "1's" to attributes first column
TXX = np.append( np.ones((XN.shape[0], 1)), TXN, axis=1);
p = predict(theta, TXX);                
print ('Accuracy: %f' % ((Y[np.where(p == Y)].size / float(Y.size)) * 100.0));
